# frozen_string_literal: true

module ErgomentumRspec
  module Helpers
    class EnvVarMockService
      def self.instance
        @instance ||= new
      end

      def initialize
        @original_env_values = {}
      end

      def mock_environment_variables(env_hash)
        env_hash.each do |key, value|
          remember_original_env_value(key)
          ENV[key] = value
        end
      end

      def restore_original_env_vars
        @original_env_values.each do |key, value|
          ENV[key] = value
        end
        @original_env_values = {}
      end

      private

      def remember_original_env_value(key)
        return if @original_env_values.key?(key)

        @original_env_values[key] = ENV[key]
      end
    end
  end
end
