# frozen_string_literal: true

module ErgomentumRspec
  module Helpers
    module Environment
      def mock_environment_variables(env_hash)
        # Using stub_const("ENV", ENV.to_h.merge(env_hash)) as simple solution does not work when using cuprite
        # in feature specs. Something seems to rely on the concrete implementation of ENV.
        # When we stub the const ENV with a Hash in such feature specs the whole ruby environment crashes.
        EnvVarMockService.instance.mock_environment_variables(env_hash)
      end
    end

    RSpec.configure do |config|
      config.include Environment
      config.after { EnvVarMockService.instance.restore_original_env_vars }
    end
  end
end
