# frozen_string_literal: true

module ErgomentumRspec
  module Helpers
    module Fixture
      def load_fixture(relative_path)
        File.read(fixture(relative_path))
      end

      def fixture(relative_path)
        fixtures_directory / relative_path
      end

      def fixtures_directory
        spec_directory / "fixtures"
      end

      def spec_directory
        Pathname.getwd / "spec"
      end
    end

    RSpec.configure do |config|
      config.include Fixture
    end
  end
end
