# frozen_string_literal: true

module ErgomentumRspec
  module Matchers
    module Array
      def be_strictly_decreasing
        StrictlyDecreasing.new
      end

      class StrictlyDecreasing
        def matches?(actual)
          @actual = actual
          derivative = actual.each_cons(2).map { |x, y| y <=> x }
          derivative.all?(&:negative?)
        end

        def failure_message
          "expected array #{@actual.inspect} to be strictly decreasing"
        end

        def failure_message_when_negated
          "expected array #{@actual.inspect} to not be strictly decreasing"
        end

        def description
          "be strictly decreasing"
        end
      end
    end
  end
end
