# frozen_string_literal: true

module ErgomentumRspec
  module Matchers
    module Array
      def be_strictly_increasing
        StrictlyIncreasing.new
      end

      class StrictlyIncreasing
        def matches?(actual)
          @actual = actual
          derivative = actual.each_cons(2).map { |x, y| y <=> x }
          derivative.all?(&:positive?)
        end

        def failure_message
          "expected array #{@actual.inspect} to be strictly increasing"
        end

        def failure_message_when_negated
          "expected array #{@actual.inspect} to not be strictly increasing"
        end

        def description
          "be strictly increasing"
        end
      end
    end
  end
end
