# frozen_string_literal: true

module ErgomentumRspec
  module Matchers
    module Array
      def be_unique
        BeUnique.new
      end

      class BeUnique
        def matches?(actual)
          @actual = actual
          actual.find { |e| actual.count(e) == 1 }
        end

        def failure_message
          "expected array #{@actual.inspect} to be unique"
        end

        def failure_message_when_negated
          "expected array #{@actual.inspect} to be not unique"
        end

        def description
          "be unique"
        end
      end
    end
  end
end
